/*
 * Created on 10 juin 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package modulecoFramework.utils.graphicalWatcher;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import madkit.kernel.Probe;
import madkit.kernel.ReferenceableAgent;
import madkit.kernel.Watcher;
import madkit.simulation.probes.ObjectProbe;
import madkit.simulation.probes.ReflexiveProbe;
import modulecoFramework.Moduleco;
import modulecoFramework.utils.graphicalWatcher.probes.AbstractMemoryProbe;
import modulecoFramework.utils.graphicalWatcher.probes.SumMemoryProbe;
import modulecoFramework.utils.graphicalWatcher.watchers.AbstractChartWatcher;
import modulecoFramework.utils.graphicalWatcher.watchers.AutoCountWatcher;
import modulecoFramework.utils.graphicalWatcher.watchers.CountWatcher;
import modulecoFramework.utils.graphicalWatcher.watchers.LineChartWatcher;
import modulecoFramework.utils.graphicalWatcher.watchers.NormalWatcher;

/**
 * @author Thibaud Roussillat
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GraphicalWatcher extends Watcher implements ReferenceableAgent {

	/*ReflexiveProbe rp1;
	ObjectProbe op1;
	Probe probe, probe2, probe3;*/
	
	List listMemoryProbe;
	Map mapMemoryProbe;
	
	List listChartWatcher;
	
	public GraphicalWatcher() {
		//System.out.println("GraphicalWatcher : GraphicalWatcher()");
	}
	
	public void activate() {
   		
		//System.out.println("GraphicalWatcher : activate()");
   		this.createGroup(false, Moduleco.COMMUNITY, "WatcherGroup", "WatcherGroup", null);
   		this.requestRole(Moduleco.COMMUNITY, "WatcherGroup","WatcherRole", null);
   		
   		listMemoryProbe = new ArrayList();
   		listChartWatcher = new ArrayList();
   		
   		//System.out.println("New Graphical Watcher");
   		
	}    
	
	/*public void addChartWatcher(AbstractChartWatcher abstractChartWatcher) {
		System.out.println("GraphicalWatcher : addChartWatcher()");
		abstractChartWatcher.step();
		//launchAgent(abstractChartWatcher,"Watcher",false);
	}*/
	
	public void addMemoryProbe(AbstractMemoryProbe memoryProbe) {
		this.addProbe(memoryProbe);
		memoryProbe.step();
		listMemoryProbe.add(memoryProbe);
	}
	
	public void validate(String community, String group, String role, String field) {
		
		ReflexiveProbe reflexiveProbe = new ReflexiveProbe(community,group,role,field);
		
	}
	
	public void observeAgents() {
		try {
			//System.out.println("ObserveAgent");
			/**
			 * TODO : modify to listMemoryProbe
			 */
			Probe[] probes = this.getProbes();
			for (int i=0;i<probes.length;i++) {
				//System.out.println("Probe class : "+probes[i].getClass());
				if (probes[i] instanceof AbstractMemoryProbe ) {
					AbstractMemoryProbe memoryProbe = (AbstractMemoryProbe) probes[i];
					memoryProbe.step();
				}
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Probe createProbe(String community, String group, String role) {
		Probe probe = new Probe(community, group, role);
        addProbe(probe);
        return probe;
	}
	
	public String[] getCommunities() {
		return this.getAvailableCommunities();
	}
	
	public String[] getGroups(String community) {
		return this.getExistingGroups(community);
	}
	
	public String[] getRoles(String community, String group) {
		return this.getExistingRoles(community,group);
	}
	
	public LineChartWatcher createLineChartWatcher() {
		LineChartWatcher lineChartWatcher = new LineChartWatcher();
		launchAgent(lineChartWatcher,"Watcher",false);
		return lineChartWatcher;
	}

	public NormalWatcher createNormalWatcher() {
		NormalWatcher normalWatcher = new NormalWatcher();
		launchAgent(normalWatcher,"Watcher",false);
		return normalWatcher;
	}

	public CountWatcher createCountWatcher() {
		CountWatcher countWatcher = new CountWatcher();
		launchAgent(countWatcher,"Watcher",false);
		return countWatcher;
	}
	
	public AutoCountWatcher createAutoCountWatcher() {
		AutoCountWatcher autoCountWatcher = new AutoCountWatcher();
		launchAgent(autoCountWatcher,"Watcher",false);
		return autoCountWatcher;
	}
	
}
