/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package modulecoGUI.grapheco;

import javax.swing.Icon;
import javax.swing.JComponent;

import net.infonode.gui.icon.IconProvider;

import modulecoFramework.modeleco.CAgent;
import modulecoGUI.CentralControl;

/**
 * @author Thibaud Roussillat
 *
 * Cette classe est une reprsentation abstraite d'un agent de type CAgent. Les mthodes communes aux diffrentes
 * sous-classes sont implmentes ici : setName, getName, setIcon, getIcon, setCAgent, ...
 * Les mthodes spcifiques tel que paint(Graphics g) ou updateImage() devront tre dfinies dans 
 * les sous-classes.
 * 
 */

public abstract class AbstractCAgentRepresentation extends JComponent implements CAgentRepresentation, IconProvider {
	
	protected String defaultPosition = "RIGTH";
	
	static public String LEFT_POSITION = "LEFT";
	static public String RIGTH_POSITION = "RIGTH";
	static public String BOTTOM_POSITION = "BOTTOM";
	
	protected String name = "World";
	
	protected CAgent cAgent;
	
	protected CentralControl centralControl;
	
	protected Icon icon;
	
	/**
	 * getter and setter for the icon
	 */
	public Icon getIcon() {
		return icon;
	}
	
	public void setIcon(Icon icon) {
		this.icon = icon;
	}
	
	public String getDefaultPosition() {
		return defaultPosition;
	}
	
	public void setDefaultPosition(String defaultPosition) {
		this.defaultPosition = defaultPosition;
	}
	
	/**
	 * getter and setter for the name of the Representation
	 */
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	/**
	 * Getter and setter for the CAgent represented by the AgentRepresentation
	 */
	public void setCAgent(CAgent cAgent) {
		this.cAgent = cAgent;
	}
	
	public CAgent getCAgent() {
		return this.cAgent;
	}

	/**
	 * getter and setter for the CentralControl
	 */
	public void setCentralControl(CentralControl centralControl) {
		this.centralControl = centralControl;
	}
	
	public CentralControl getCentralControl() {
		return this.centralControl;
	}
}
