package turtlekit.simulations.hunt2CyanVsBlue;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Random;

import turtlekit.kernel.Turtle;

/** A Predator
 @author Fabien MICHEL
 @version 2.0 25/02/2007 */

public class Blue extends Animat 
{
	static int cpt=0;
	static int cptTour=0;
	int type=1;
	int angle=0;
	double multiDistance=2;
	static final String bleu="Blue";
	static final String orange="cyan";
	
	private ArrayList<Animat> tabOrange;  
	private ArrayList<Animat> tabBlue;
	
	/**
	 * @param visionRadius
	 * @param initLife 
	 */
	public Blue(int visionRadius, int initLife) {
		
		
		super(visionRadius, initLife);
		type=1;
		
	}
	
	public void setup()
	{
		playRole(bleu);
		randomHeading();
		setColor(Color.blue);
	} 
	
	public String live()
	{
		
		boolean action=false;
		
		
		
		/*	if (cpt<1000)
		 {
		 reproduce("Blue");
		 action=true;
		 }
		 
		 if (cpt<15000 && action==false)
		 {
		 fleeingPredators(3);
		 if (life>1)
		 move();
		 brouter();
		 action=true;
		 }
		 
		 if (!getPreys().isEmpty() && !action)
		 {
		 manger();
		 action=true;
		 }
		 
		 
		 if(countTurtlesHere()>1 && life>1 && !action)
		 {
		 move();
		 if(manger())
		 action=true;
		 else
		 brouter();
		 action=true;
		 }
		 
		 if (life>9 && !action)
		 {
		 if(manger())
		 action=true;
		 else
		 reproduce("Blue");
		 action=true;
		 }
		 if (life<10 && action==false)
		 {
		 if(manger())
		 action=true;
		 else
		 brouter();
		 action=true;
		 }
		 
		 cpt++;
		 return "live";
		 */
		
		
		
		
		if(manger())
		{		
			move();
		}
		else
		{
			if (cpt%200>50 && action==false)
			{
				
				fleeingPredators(1);
				move();
				brouter();
				action=true;
			}
			else
			{
				
				move();
				reproduce();
				cptTour++;
				
			}
			
		}
		
		if (cpt%3==0)
		{
			angle+=45;
		}
		
		
		
		
		setHeading(angle%360);
		cpt++;
		return "live";
		
		
	}

	protected void reproduce(){
		life-=life/2;
		Blue t=new Blue(visionRadius,life);
		createTurtle(t);		
	}
	
	
	private ArrayList<Turtle> getPreys(){
		
		ArrayList<Turtle> preys = new ArrayList<Turtle>();
		Turtle[] animats = turtlesHere();
		if(animats!=null){
			for (int i = 0; i < animats.length; i++) {
				if(animats[i].isPlayingRole(orange)){
					preys.add((Animat)animats[i]);
				}
			}
		}
		return preys;
	}
	
	boolean fleeingPredators(int radius){
		double x=xcor();
		double y=ycor();
		
		for(int i=-radius;i<=radius;i++){
			for(int j=-radius;j<=radius;j++){
				if (! (i==0 && j==0) )
				{
					int dx=1+radius-Math.abs(i);
					int dy=1+radius-Math.abs(j);
					Turtle[] tur = turtlesAt(i,j);
					for (int k = 0; k < tur.length; k++){
						if (tur[k].isPlayingRole(orange))
						{// && ((Animat)tur[k]).getLife()>0){ //instead of "instanceof". So prey can be another java class
							x-= multiDistance*dx*(tur[k].xcor()-xcor());
							y-= multiDistance*dy*(tur[k].ycor()-ycor());
						}
					}			
				}
			}
		}
		if((int)x!=xcor() || (int)y!=ycor()){
			setHeading( towards(x,y));
			return true;
		}
		return false;
		
	}
	
	
	
	
	
	
	private void brouter(){
		double resource = getPatchVariable("resource");
		if (resource>0){
			life+=resource;
			incrementPatchVariable("resource", -resource);
		}
	}
	
	
	
	boolean manger()
	{		
		// Mange la cible ayant le plus de vie
		ArrayList<Animat> Oranges = getOrangesHere();
		int l=0;
		int j=0;
		if(! Oranges.isEmpty())
		{
			for (int i=0; i<Oranges.size();i++)
			{
				if (Oranges.get(i).getLife()>l)
				{
					l=Oranges.get(i).getLife();
					j=i;
				}
			}
			eatOrange(Oranges.get(j));
			return true;
		}
		return false;
	}
	
	private ArrayList<Animat> getOrangesHere(){
		ArrayList<Animat> preys = new ArrayList<Animat>();
		Turtle[] animats = turtlesHere();
		for (int i = 0; i < animats.length; i++) {
			if(animats[i].isPlayingRole(orange))
				preys.add((Animat)animats[i]);
		}
		return preys;
	}
	
	
	
	
	
	
	
	
	
	double towardsAOrange(int radius)
	{
		for(int i=-radius;i<=radius;i++)
			for(int j=-radius;j<=radius;j++)
				if (! (i==0 && j==0) )
				{
					Turtle[] tur = turtlesAt(i,j);
					for (int k = 0; k < tur.length; k++)
						if (tur[k].isPlayingRole(orange)) //instead of "instanceof". So Orange can be another java class
							return towards(tur[0].xcor(),tur[0].ycor());
				}
		return Math.random()*180;
	}
	
	
	
	private void eatOrange(Animat p) {
		life += p.getLife();
		p.die();
	}
	
	
	
}








